Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeIonisationModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeIonisationModel.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeIonisationModel.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PenelopeIonisationModel.cc,v 1.2 2008/12/05 09:15:43 pandola Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PenelopeIonisationModel.cc,v 1.5 2009/05/19 14:57:01 pandola Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Author: Luciano Pandola
@@ -32,4 +32,11 @@
 // --------
 // 26 Nov 2008   L Pandola    Migration from process to model 
+// 17 Apr 2009   V Ivanchenko Cleanup initialisation and generation of secondaries:
+//                  - apply internal high-energy limit only in constructor 
+//                  - do not apply low-energy limit (default is 0)
+//                  - added MinEnergyCut method
+//                  - do not change track status
+// 19 May 2009   L Pandola    Explicitely set to zero pointers deleted in 
+//                            Initialise(), since they might be checked later on
 //
 
@@ -48,5 +55,4 @@
 #include "G4CrossSectionHandler.hh"
 #include "G4AtomicDeexcitation.hh"
-#include "G4ProcessManager.hh"
 #include "G4VEMDataSet.hh"
 
@@ -68,5 +74,5 @@
   fIntrinsicLowEnergyLimit = 100.0*eV;
   fIntrinsicHighEnergyLimit = 100.0*GeV;
-  SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
+  //  SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
   SetHighEnergyLimit(fIntrinsicHighEnergyLimit);
   //
@@ -136,6 +142,4 @@
     G4cout << "Calling G4PenelopeIonisationModel::Initialise()" << G4endl;
 
-  InitialiseElementSelectors(particle,cuts);
-
   //Delete and re-initialize the cross section handler
   if (crossSectionHandler)
@@ -143,4 +147,5 @@
       crossSectionHandler->Clear();
       delete crossSectionHandler;
+      crossSectionHandler = 0;
     }
 
@@ -148,21 +153,11 @@
     {
       for (size_t i=0; i<theXSTable->size(); i++)
-	delete (*theXSTable)[i];
+	{
+	  delete (*theXSTable)[i];
+	  (*theXSTable)[i] = 0;
+	}
       delete theXSTable;
+      theXSTable = 0;
      }
-
-
-  if (LowEnergyLimit() < fIntrinsicLowEnergyLimit)
-    {
-      G4cout << "G4PenelopeIonisationModel: low energy limit increased from " << 
-	LowEnergyLimit()/eV << " eV to " << fIntrinsicLowEnergyLimit/eV << " eV" << G4endl;
-      SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
-    }
-  if (HighEnergyLimit() > fIntrinsicHighEnergyLimit)
-    {
-      G4cout << "G4PenelopeIonisationModel: high energy limit decreased from " << 
-	HighEnergyLimit()/GeV << " GeV to " << fIntrinsicHighEnergyLimit/GeV << " GeV" << G4endl;
-      SetHighEnergyLimit(fIntrinsicHighEnergyLimit);
-    }
 
   crossSectionHandler = new G4CrossSectionHandler();
@@ -177,21 +172,20 @@
   //This is used to retrieve cross section values later on
   crossSectionHandler->BuildMeanFreePathForMaterials();
-  
- if (verboseLevel > 2) 
+
+  InitialiseElementSelectors(particle,cuts);
+  
+  if (verboseLevel > 2) 
     G4cout << "Loaded cross section files for PenelopeIonisationModel" << G4endl;
 
-
-  G4cout << "Penelope Ionisation model is initialized " << G4endl
-         << "Energy range: "
-         << LowEnergyLimit() / keV << " keV - "
-         << HighEnergyLimit() / GeV << " GeV"
-         << G4endl;
+  if (verboseLevel > 2) {
+    G4cout << "Penelope Ionisation model is initialized " << G4endl
+	   << "Energy range: "
+	   << LowEnergyLimit() / keV << " keV - "
+	   << HighEnergyLimit() / GeV << " GeV"
+	   << G4endl;
+  }
 
   if(isInitialised) return;
-
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForLoss*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForLoss();
+  fParticleChange = GetParticleChangeForLoss();
   isInitialised = true; 
 }
@@ -227,4 +221,6 @@
   SetupForMaterial(theParticle, material, energy);
 
+  // VI - should be check at initialisation not in run time
+  /*
   if (!crossSectionHandler)
     {
@@ -233,5 +229,5 @@
       G4Exception();
     }
-  
+  */  
   if (!theXSTable)
     {
@@ -244,5 +240,5 @@
       theXSTable = BuildCrossSectionTable(theParticle); 
     }
-
+  
   G4double totalCross = 0.0; 
   G4double cross = 0.0;
@@ -356,6 +352,5 @@
 					      const G4MaterialCutsCouple* couple,
 					      const G4DynamicParticle* aDynamicParticle,
-					      G4double,
-					      G4double)
+					      G4double cutE, G4double)
 {
   // Penelope model to sample the final state following an hard inelastic interaction.
@@ -397,14 +392,8 @@
   const G4ParticleDefinition* theParticle = aDynamicParticle->GetDefinition();
 
-  if (kineticEnergy0 <= LowEnergyLimit())
+  if (kineticEnergy0 <= fIntrinsicLowEnergyLimit)
   {
     fParticleChange->SetProposedKineticEnergy(0.);
     fParticleChange->ProposeLocalEnergyDeposit(kineticEnergy0);
-    //Check if there are AtRest processes
-    if (theParticle->GetProcessManager()->GetAtRestProcessVector()->size()) 
-      //In this case there is at least one AtRest process
-      fParticleChange->ProposeTrackStatus(fStopButAlive);
-    else
-      fParticleChange->ProposeTrackStatus(fStopAndKill);
     return ;
   }
@@ -430,15 +419,8 @@
   G4int iZ = SampleRandomAtom(couple,kineticEnergy0);
   
-  G4double cutForLowEnergySecondaryParticles = 250.0*eV;
   const G4ProductionCutsTable* theCoupleTable=
     G4ProductionCutsTable::GetProductionCutsTable();
   size_t indx = couple->GetIndex();
-  G4double cutE = (*(theCoupleTable->GetEnergyCutsVector(1)))[indx];
   G4double cutG = (*(theCoupleTable->GetEnergyCutsVector(0)))[indx];
-
-  //Production cut for delta-rays (electrons)
-  cutE = std::max(cutForLowEnergySecondaryParticles,cutE);
-  //Production cut for gamma (fluorescence)
-  cutG = std::max(cutForLowEnergySecondaryParticles,cutG);
   
   if (verboseLevel > 2)
@@ -474,11 +456,5 @@
   else
     {
-      fParticleChange->ProposeMomentumDirection(electronDirection1);
-      fParticleChange->SetProposedKineticEnergy(0.*eV);
-      if (theParticle->GetProcessManager()->GetAtRestProcessVector()->size()) 
-	//In this case there is at least one AtRest process
-	fParticleChange->ProposeTrackStatus(fStopButAlive);
-      else
-	fParticleChange->ProposeTrackStatus(fStopAndKill);
+      fParticleChange->SetProposedKineticEnergy(0.);
     }
   
@@ -517,36 +493,40 @@
     //Penelope subtracted the fluorescence, but one has to match the databases
     eKineticEnergy = energySecondary+ioniEnergy-bindingEnergy;
-    
-  //VERIFICA QUI LA STORIA DEL LOCAL ENERGY DEPOSIT!
-
+  
   G4double localEnergyDeposit = ionEnergy; 
   G4double energyInFluorescence = 0.0*eV;
 
-   std::vector<G4DynamicParticle*> *photonVector = 0;
-  if (fUseAtomicDeexcitation)
-    {
-      if (iZ>5 && (ionEnergy > cutG || ionEnergy > cutE))
+  if(DeexcitationFlag() && iZ > 5) 
+    {
+      if (ionEnergy > cutG || ionEnergy > cutE)
 	{
-	  photonVector = deexcitationManager.GenerateParticles(iZ,shellId);
-	  //Check for single photons if they are above threshold
-	  for (size_t k=0;k<photonVector->size();k++)
+	  deexcitationManager.SetCutForSecondaryPhotons(cutG);
+	  deexcitationManager.SetCutForAugerElectrons(cutE);
+	  std::vector<G4DynamicParticle*> *photonVector =
+	    deexcitationManager.GenerateParticles(iZ,shellId);
+	  //Check for secondaries
+          if(photonVector) 
 	    {
-	      G4DynamicParticle* aPhoton = (*photonVector)[k];
-	      if (aPhoton)
+	      for (size_t k=0;k<photonVector->size();k++)
 		{
-		  G4double itsCut = cutG;
-		  if (aPhoton->GetDefinition() == G4Electron::Electron()) itsCut = cutE;
-		  G4double itsEnergy = aPhoton->GetKineticEnergy();
-		  if (itsEnergy > itsCut && itsEnergy <= ionEnergy)
+		  G4DynamicParticle* aPhoton = (*photonVector)[k];
+		  if (aPhoton)
 		    {
-		      localEnergyDeposit -= itsEnergy;
-		      energyInFluorescence += itsEnergy;
-		    }
-		  else
-		    {
-		      delete aPhoton;
-		      (*photonVector)[k] = 0;
+		      G4double itsEnergy = aPhoton->GetKineticEnergy();
+		      if (itsEnergy <= localEnergyDeposit)
+			{
+			  if(aPhoton->GetDefinition() == G4Gamma::Gamma())
+			    energyInFluorescence += itsEnergy;
+			  localEnergyDeposit -= itsEnergy;
+			  fvect->push_back(aPhoton);
+			}
+		      else
+			{
+			  delete aPhoton;
+			  (*photonVector)[k] = 0;
+			}
 		    }
 		}
+	      delete photonVector;
 	    }
 	}
@@ -567,18 +547,4 @@
   fvect->push_back(deltaElectron);
   
-  //Generate fluorescence, if it is the case
-  //This block is executed only if there is at least one secondary photon produced by 
-  //G4AtomicDeexcitation
-  if (photonVector)
-    {
-      for (size_t ll=0;ll<photonVector->size();ll++)
-	if ((*photonVector)[ll])
-	  {
-	    G4DynamicParticle* aFluorescencePhoton = (*photonVector)[ll];
-	    fvect->push_back(aFluorescencePhoton);
-	  }
-    }
-  delete photonVector;
-
   if (localEnergyDeposit < 0)
     {
@@ -753,6 +719,9 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-void G4PenelopeIonisationModel::CalculateDiscreteForElectrons(G4double kinEnergy,G4double cutoffEnergy,
-							      G4int Z,G4double electronVolumeDensity)
+void 
+G4PenelopeIonisationModel::CalculateDiscreteForElectrons(G4double kinEnergy,
+							 G4double cutoffEnergy,
+							 G4int Z,
+							 G4double electronVolumeDensity)
 {
   if (verboseLevel > 2)
@@ -1030,6 +999,9 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
- void G4PenelopeIonisationModel::CalculateDiscreteForPositrons(G4double kinEnergy,G4double cutoffEnergy,
-							       G4int Z,G4double electronVolumeDensity)
+ void 
+G4PenelopeIonisationModel::CalculateDiscreteForPositrons(G4double kinEnergy,
+							 G4double cutoffEnergy,
+							 G4int Z,
+							 G4double electronVolumeDensity)
 {
   kineticEnergy1=kinEnergy;
@@ -1287,8 +1259,9 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-G4double G4PenelopeIonisationModel::CalculateCrossSectionsRatio(G4double kinEnergy,
-								G4double cutoffEnergy,
-								G4int Z, G4double electronVolumeDensity,
-								const G4ParticleDefinition* theParticle)
+G4double 
+G4PenelopeIonisationModel::CalculateCrossSectionsRatio(G4double kinEnergy,
+						       G4double cutoffEnergy,
+						       G4int Z, G4double electronVolumeDensity,
+						       const G4ParticleDefinition* theParticle)
 {
   //Constants
@@ -1320,8 +1293,9 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-std::pair<G4double,G4double> G4PenelopeIonisationModel::CrossSectionsRatioForElectrons(G4double kineticEnergy,
-										       G4double resEnergy,
-										       G4double densityCorrection,
-										       G4double cutoffEnergy)
+std::pair<G4double,G4double> 
+G4PenelopeIonisationModel::CrossSectionsRatioForElectrons(G4double kineticEnergy,
+							  G4double resEnergy,
+							  G4double densityCorrection,
+							  G4double cutoffEnergy)
 {
   std::pair<G4double,G4double> theResult(0.,0.);
@@ -1410,8 +1384,9 @@
 //....oooOO0OOooo........oooOO0OOooo........oooOO0OOooo........oooOO0OOooo....
 
-std::pair<G4double,G4double> G4PenelopeIonisationModel::CrossSectionsRatioForPositrons(G4double kineticEnergy,
-										       G4double resEnergy,
-										       G4double densityCorrection,
-										       G4double cutoffEnergy)
+std::pair<G4double,G4double> 
+G4PenelopeIonisationModel::CrossSectionsRatioForPositrons(G4double kineticEnergy,
+							  G4double resEnergy,
+							  G4double densityCorrection,
+							  G4double cutoffEnergy)
 {
 
@@ -1640,6 +1615,6 @@
 #include "G4EMDataSet.hh"
 
-std::vector<G4VEMDataSet*>* G4PenelopeIonisationModel::BuildCrossSectionTable(const 
-									      G4ParticleDefinition* theParticle)
+std::vector<G4VEMDataSet*>* 
+G4PenelopeIonisationModel::BuildCrossSectionTable(const G4ParticleDefinition* theParticle)
 {
   std::vector<G4VEMDataSet*>* set = new std::vector<G4VEMDataSet*>;
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopePhotoElectric.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopePhotoElectric.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopePhotoElectric.cc	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4PenelopePhotoElectric.cc,v 1.12 2006/06/29 19:40:51 gunter Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PenelopePhotoElectric.cc,v 1.14 2009/05/02 09:59:17 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Author: L. Pandola
@@ -37,4 +37,9 @@
 // 31 May 2005  L. Pandola  Added Sauter formula for the sampling of 
 //                          the electron direction
+// 08 Jan 2009  L. Pandola  Check shell index to avoid mismatch between 
+//                          the Penelope cross section database and the 
+//                          G4AtomicTransitionManager database. It suppresses 
+//                          a warning from G4AtomicTransitionManager only. 
+//                          Results are unchanged.
 // --------------------------------------------------------------
 
@@ -89,4 +94,15 @@
 	     << G4endl;
     }
+
+   G4cout << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "   The class G4PenelopePhotoElectric is NOT SUPPORTED ANYMORE. " << G4endl;
+   G4cout << "   It will be REMOVED with the next major release of Geant4. " << G4endl;
+   G4cout << "   Please consult: https://twiki.cern.ch/twiki/bin/view/Geant4/LoweProcesses" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << G4endl;
+
 }
 
@@ -146,4 +162,15 @@
   // Retrieve the corresponding identifier and binding energy of the selected shell
   const G4AtomicTransitionManager* transitionManager = G4AtomicTransitionManager::Instance();
+
+  //The number of shell cross section possibly reported in the Penelope database 
+  //might be different from the number of shells in the G4AtomicTransitionManager
+  //(namely, Penelope may contain more shell, especially for very light elements).
+  //In order to avoid a warning message from the G4AtomicTransitionManager, I 
+  //add this protection. Results are anyway changed, because when G4AtomicTransitionManager
+  //has a shellID>maxID, it sets the shellID to the last valid shell. 
+  size_t numberOfShells = (size_t) transitionManager->NumberOfShells(Z);
+  if (shellIndex >= numberOfShells)
+    shellIndex = numberOfShells-1;
+
   const G4AtomicShell* shell = transitionManager->Shell(Z,shellIndex);
   G4double bindingEnergy = shell->BindingEnergy();
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopePhotoElectricModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopePhotoElectricModel.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopePhotoElectricModel.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4PenelopePhotoElectricModel.cc,v 1.2 2008/12/04 14:09:36 pandola Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PenelopePhotoElectricModel.cc,v 1.6 2009/05/19 14:57:01 pandola Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Author: Luciano Pandola
@@ -31,5 +31,17 @@
 // History:
 // --------
-// 08 Oct 2008   L Pandola    Migration from process to model 
+// 08 Oct 2008   L Pandola  Migration from process to model 
+// 08 Jan 2009   L Pandola  Check shell index to avoid mismatch between 
+//                          the Penelope cross section database and the 
+//                          G4AtomicTransitionManager database. It suppresses 
+//                          a warning from G4AtomicTransitionManager only. 
+//                          Results are unchanged.
+// 25 Mar 2009   L Pandola  Small fix to avoid wrong energy-violation warnings
+// 17 Apr 2009   V Ivanchenko Cleanup initialisation and generation of secondaries:
+//                  - apply internal high-energy limit only in constructor 
+//                  - do not apply low-energy limit (default is 0)
+//                  - do not apply production threshold on secondaries
+// 19 May 2009   L Pandola    Explicitely set to zero pointers deleted in 
+//                            Initialise(), since they might be checked later on
 //
 
@@ -58,5 +70,5 @@
   fIntrinsicLowEnergyLimit = 100.0*eV;
   fIntrinsicHighEnergyLimit = 100.0*GeV;
-  SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
+  //  SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
   SetHighEnergyLimit(fIntrinsicHighEnergyLimit);
   //
@@ -90,4 +102,5 @@
       crossSectionHandler->Clear();
       delete crossSectionHandler;
+      crossSectionHandler = 0;
     }
   if (shellCrossSectionHandler)
@@ -95,22 +108,6 @@
       shellCrossSectionHandler->Clear();
       delete shellCrossSectionHandler;
-    }
-
-  //Check energy limits
-  if (LowEnergyLimit() < fIntrinsicLowEnergyLimit)
-    {
-      G4cout << "G4PenelopePhotoElectricModel: low energy limit increased from " <<
-        LowEnergyLimit()/eV << " eV to " << fIntrinsicLowEnergyLimit/eV << " eV" << 
-	G4endl;
-      SetLowEnergyLimit(fIntrinsicLowEnergyLimit);
-    }
-  if (HighEnergyLimit() > fIntrinsicHighEnergyLimit)
-    {
-      G4cout << "G4PenelopePhotoElectricModel: high energy limit decreased from " <<
-        HighEnergyLimit()/GeV << " GeV to " << fIntrinsicHighEnergyLimit/GeV << " GeV" 
-	     << G4endl;
-      SetHighEnergyLimit(fIntrinsicHighEnergyLimit);
-    }
-
+      shellCrossSectionHandler =0;
+    }
 
   //Re-initialize cross section handlers
@@ -129,16 +126,14 @@
     G4cout << "Loaded cross section files for PenelopePhotoElectric" << G4endl;
 
-  G4cout << "Penelope Photo-Electric model is initialized " << G4endl
-         << "Energy range: "
-         << LowEnergyLimit() / MeV << " MeV - "
-         << HighEnergyLimit() / GeV << " GeV"
-         << G4endl;
+  if (verboseLevel > 0) { 
+    G4cout << "Penelope Photo-Electric model is initialized " << G4endl
+	   << "Energy range: "
+	   << LowEnergyLimit() / MeV << " MeV - "
+	   << HighEnergyLimit() / GeV << " GeV"
+	   << G4endl;
+  }
 
   if(isInitialised) return;
-
-  if(pParticleChange)
-    fParticleChange = reinterpret_cast<G4ParticleChangeForGamma*>(pParticleChange);
-  else
-    fParticleChange = new G4ParticleChangeForGamma();
+  fParticleChange = GetParticleChangeForGamma();
   isInitialised = true;
 }
@@ -162,10 +157,10 @@
 
   G4int iZ = (G4int) Z;
-  if (!crossSectionHandler)
-    {
-      G4cout << "G4PenelopePhotoElectricModel::ComputeCrossSectionPerAtom" << G4endl;
-      G4cout << "The cross section handler is not correctly initialized" << G4endl;
-      G4Exception();
-    }
+  //  if (!crossSectionHandler) // VI: should not be 
+  //  {
+  //    G4cout << "G4PenelopePhotoElectricModel::ComputeCrossSectionPerAtom" << G4endl;
+  //    G4cout << "The cross section handler is not correctly initialized" << G4endl;
+  //    G4Exception();
+  //  }
   G4double cs = crossSectionHandler->FindValue(iZ,energy);
  
@@ -203,11 +198,13 @@
   G4double photonEnergy = aDynamicGamma->GetKineticEnergy();
 
-  if (photonEnergy <= LowEnergyLimit())
-  {
-      fParticleChange->ProposeTrackStatus(fStopAndKill);
-      fParticleChange->SetProposedKineticEnergy(0.);
+  // always kill primary
+  fParticleChange->ProposeTrackStatus(fStopAndKill);
+  fParticleChange->SetProposedKineticEnergy(0.);
+
+  if (photonEnergy <= fIntrinsicLowEnergyLimit)
+    {
       fParticleChange->ProposeLocalEnergyDeposit(photonEnergy);
       return ;
-  }
+    }
 
   G4ParticleMomentum photonDirection = aDynamicGamma->GetMomentumDirection();
@@ -217,5 +214,6 @@
     G4cout << "Going to select element in " << couple->GetMaterial()->GetName() << G4endl;
   //use crossSectionHandler instead of G4EmElementSelector because in this case 
-  //the dimension of the table is equal to the dimension of the database (less interpolation errors)
+  //the dimension of the table is equal to the dimension of the database 
+  //(less interpolation errors)
   G4int Z = crossSectionHandler->SelectRandomAtom(couple,photonEnergy);
   if (verboseLevel > 2)
@@ -227,4 +225,15 @@
   // Retrieve the corresponding identifier and binding energy of the selected shell
   const G4AtomicTransitionManager* transitionManager = G4AtomicTransitionManager::Instance();
+
+  //The number of shell cross section possibly reported in the Penelope database 
+  //might be different from the number of shells in the G4AtomicTransitionManager
+  //(namely, Penelope may contain more shell, especially for very light elements).
+  //In order to avoid a warning message from the G4AtomicTransitionManager, I 
+  //add this protection. Results are anyway changed, because when G4AtomicTransitionManager
+  //has a shellID>maxID, it sets the shellID to the last valid shell. 
+  size_t numberOfShells = (size_t) transitionManager->NumberOfShells(Z);
+  if (shellIndex >= numberOfShells)
+    shellIndex = numberOfShells-1;
+
   const G4AtomicShell* shell = transitionManager->Shell(Z,shellIndex);
   G4double bindingEnergy = shell->BindingEnergy();
@@ -236,11 +245,4 @@
   G4double eKineticEnergy = photonEnergy - bindingEnergy;
   
-  G4double cutForLowEnergySecondaryParticles = 250.0*eV;
-  const G4ProductionCutsTable* theCoupleTable=
-    G4ProductionCutsTable::GetProductionCutsTable();
-  size_t indx = couple->GetIndex();
-  G4double cutE = (*(theCoupleTable->GetEnergyCutsVector(1)))[indx];
-  cutE = std::max(cutForLowEnergySecondaryParticles,cutE);
-
   // There may be cases where the binding energy of the selected shell is > photon energy
   // In such cases do not generate secondaries
@@ -248,81 +250,75 @@
     {
       //Now check if the electron is above cuts: if so, it is created explicitely
-      if (eKineticEnergy > cutE)
-	{
-	  // The electron is created
-	  // Direction sampled from the Sauter distribution
-	  G4double cosTheta = SampleElectronDirection(eKineticEnergy);
-	  G4double sinTheta = std::sqrt(1-cosTheta*cosTheta);
-	  G4double phi = twopi * G4UniformRand() ;
-	  G4double dirx = sinTheta * std::cos(phi);
-	  G4double diry = sinTheta * std::sin(phi);
-	  G4double dirz = cosTheta ;
-	  G4ThreeVector electronDirection(dirx,diry,dirz); //electron direction
-	  electronDirection.rotateUz(photonDirection);
-	  G4DynamicParticle* electron = new G4DynamicParticle (G4Electron::Electron(), 
-							       electronDirection, 
-							       eKineticEnergy);
-	  fvect->push_back(electron);
-	} 
-      else 
-	localEnergyDeposit += eKineticEnergy;    
-    }
+      //VI: checking cut here provides inconsistency in testing
+      //      if (eKineticEnergy > cutE)
+      // The electron is created
+      // Direction sampled from the Sauter distribution
+      G4double cosTheta = SampleElectronDirection(eKineticEnergy);
+      G4double sinTheta = std::sqrt(1-cosTheta*cosTheta);
+      G4double phi = twopi * G4UniformRand() ;
+      G4double dirx = sinTheta * std::cos(phi);
+      G4double diry = sinTheta * std::sin(phi);
+      G4double dirz = cosTheta ;
+      G4ThreeVector electronDirection(dirx,diry,dirz); //electron direction
+      electronDirection.rotateUz(photonDirection);
+      G4DynamicParticle* electron = new G4DynamicParticle (G4Electron::Electron(), 
+							   electronDirection, 
+							   eKineticEnergy);
+      fvect->push_back(electron);
+    } 
+  //  else 
+  //  {
+  //    localEnergyDeposit += eKineticEnergy;    
+  //    eKineticEnergy = 0;
+  //  }
+  //  }
   else
+    {
       bindingEnergy = photonEnergy;
-    
-  
+    }
   G4double energyInFluorescence = 0; //testing purposes
 
   //Now, take care of fluorescence, if required
-  if (fUseAtomicDeexcitation)
-    {
+  if(DeexcitationFlag() && Z > 5) 
+    {
+      const G4ProductionCutsTable* theCoupleTable=
+	G4ProductionCutsTable::GetProductionCutsTable();
+      size_t indx = couple->GetIndex();
       G4double cutG = (*(theCoupleTable->GetEnergyCutsVector(0)))[indx];
-      cutG = std::min(cutForLowEnergySecondaryParticles,cutG);
+      G4double cutE = (*(theCoupleTable->GetEnergyCutsVector(1)))[indx];
       
-      std::vector<G4DynamicParticle*>* photonVector = 0;
-
       // Protection to avoid generating photons in the unphysical case of 
       // shell binding energy > photon energy
-      if (Z > 5  && (bindingEnergy > cutG || bindingEnergy > cutE))
+      if (bindingEnergy > cutG || bindingEnergy > cutE)
 	{
-	  photonVector = deexcitationManager.GenerateParticles(Z,shellId); 
-	  //Check for single photons (if they are above threshold)
-	  for (size_t k=0; k< photonVector->size(); k++)
+	  deexcitationManager.SetCutForSecondaryPhotons(cutG);
+	  deexcitationManager.SetCutForAugerElectrons(cutE);
+	  std::vector<G4DynamicParticle*>* photonVector = 
+	    deexcitationManager.GenerateParticles(Z,shellId); 
+	  //Check for secondaries
+          if(photonVector) 
 	    {
-	      G4DynamicParticle* aPhoton = (*photonVector)[k];
-	      if (aPhoton)
+	      for (size_t k=0; k< photonVector->size(); k++)
 		{
-		  G4double itsCut = cutG;
-		  if(aPhoton->GetDefinition() == G4Electron::Electron()) itsCut = cutE;
-		  G4double itsEnergy = aPhoton->GetKineticEnergy();
-		  
-		  if (itsEnergy > itsCut && itsEnergy <= bindingEnergy)
+		  G4DynamicParticle* aPhoton = (*photonVector)[k];
+		  if (aPhoton)
 		    {
-		      // Local energy deposit is given as the sum of the 
-		      // energies of incident photons minus the energies
-		      // of the outcoming fluorescence photons
-		      bindingEnergy -= itsEnergy;
-		      
-		    }
-		  else
-		    { 
-		      (*photonVector)[k] = 0;
+		      G4double itsEnergy = aPhoton->GetKineticEnergy();
+		      if (itsEnergy <= bindingEnergy)
+			{
+			  if(aPhoton->GetDefinition() == G4Gamma::Gamma())
+			    energyInFluorescence += itsEnergy;
+			  bindingEnergy -= itsEnergy;
+			  fvect->push_back(aPhoton);
+			}
+		      else
+			{
+			  delete aPhoton;
+			  (*photonVector)[k] = 0;
+			}
 		    }
 		}
+	      delete photonVector;
 	    }
-	}
-      //Register valid secondaries
-      if (photonVector)
-	{
-	  for ( size_t ll = 0; ll <photonVector->size(); ll++) 
-	    {
-	      G4DynamicParticle* aPhoton = (*photonVector)[ll];
-	      if (aPhoton) 
-		{
-		  energyInFluorescence += aPhoton->GetKineticEnergy();
-		  fvect->push_back(aPhoton);
-		}
-	    }
-	  delete photonVector;
 	}
     }
@@ -330,5 +326,4 @@
   localEnergyDeposit += bindingEnergy;
       
-
   if (localEnergyDeposit < 0)
     {
@@ -339,8 +334,5 @@
     }
 
- //Update the status of the primary gamma (kill it)
-  fParticleChange->SetProposedKineticEnergy(0.);
   fParticleChange->ProposeLocalEnergyDeposit(localEnergyDeposit);
-  fParticleChange->ProposeTrackStatus(fStopAndKill);
 
   if (verboseLevel > 1)
@@ -360,8 +352,10 @@
   if (verboseLevel > 0)
     {
-      G4double energyDiff = std::fabs(eKineticEnergy+energyInFluorescence+localEnergyDeposit-photonEnergy);
+      G4double energyDiff = 
+	std::fabs(eKineticEnergy+energyInFluorescence+localEnergyDeposit-photonEnergy);
       if (energyDiff > 0.05*keV)
 	G4cout << "Warning from G4PenelopePhotoElectric: problem with energy conservation: " << 
-	  (eKineticEnergy+energyInFluorescence+localEnergyDeposit)/keV << " keV (final) vs. " << 
+	  (eKineticEnergy+energyInFluorescence+localEnergyDeposit)/keV 
+	       << " keV (final) vs. " << 
 	  photonEnergy/keV << " keV (initial)" << G4endl;
     }
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeRayleigh.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeRayleigh.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4PenelopeRayleigh.cc	(revision 1055)
@@ -26,6 +26,6 @@
 // --------------------------------------------------------------------
 //
-// $Id: G4PenelopeRayleigh.cc,v 1.15 2007/09/03 09:43:14 pandola Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4PenelopeRayleigh.cc,v 1.17 2009/05/02 09:59:17 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 //
 // Author: L. Pandola (luciano.pandola@cern.ch)
@@ -41,4 +41,7 @@
 // 03 Sep 2007 L.Pandola      Bug fix for the filling of physics table for 
 //                            compounds defined by the mass fraction (bug #965)
+// 02 Apr 2009 L.Pandola      Bux fixed in the calculation of mfp for compound 
+//                            materials defined as fraction of mass 
+//                            (reported by Zhang Qiwei)
 // --------------------------------------------------------------------
 
@@ -93,4 +96,14 @@
 	      << G4endl;
      }
+
+   G4cout << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "   The class G4PenelopeRayleigh is NOT SUPPORTED ANYMORE. " << G4endl;
+   G4cout << "   It will be REMOVED with the next major release of Geant4. " << G4endl;
+   G4cout << "   Please consult: https://twiki.cern.ch/twiki/bin/view/Geant4/LoweProcesses" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << G4endl;
 }
 
@@ -162,5 +175,7 @@
 	  const G4double* vector_of_atoms = material->GetVecNbOfAtomsPerVolume();
 	  const G4int* stechiometric = material->GetAtomsVector();
-	  G4double density = vector_of_atoms[iright]; //non-bound molecules (default)
+	  //cs is the cross section _per atom_ in the case of compounds, while it is 
+	  //_per molecule_ in the case of molecules
+	  G4double density = material->GetTotNbOfAtomsPerVolume();  //non-bound molecules (default)
 	  if (stechiometric)
 	    {
